---
title: Device Memory API
slug: Web/API/Device_Memory_API
tags:
  - Device Memory API
---
<p>{{DefaultAPISidebar("Device Memory API")}}{{securecontext_header}}{{SeeCompatTable}}</p>

<p class="summary">Capabilities of the client devices largely depend on the amount of available RAM. Traditionally, developrs had to use heruistics and either benchmark the device or infer the device capabilities based on other factors like device manufacturer or User Agent strings.</p>

<h2 id="Accessing_device_memory_capacity">Accessing device memory capacity</h2>

<p>There are two ways to acces the approximate amount of RAM device has: via JavaScript API and via Client Hints HTTP header.</p>

<h3 id="JavaScript_API">JavaScript API</h3>

<p>You may query the approximate amount of ram device has by retreiving {{DOMxRef("Navigator.deviceMemory")}}</p>

<pre class="brush:js notranslate">var ram1 = window.navigator.deviceMemory;
var ram2 = navigator.deviceMemory;
</pre>

<p>Both of these will return the same result.</p>

<h3 id="Client_Hints_Header">Client Hints Header</h3>

<p>You also may use <a href="/en-US/docs/Glossary/Client_hints">Client Hints</a> directive <code>Device-Memory</code> to retreive the same approximate RAM capacity.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Device Memory")}}</td>
   <td>{{Spec2("Device Memory")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<h3 id="JavaScript_interface">JavaScript interface</h3>

<p>{{Compat("api.Navigator.deviceMemory")}}</p>

<h3 id="Client_Hints_extension">Client Hints extension</h3>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("http.headers.Device-Memory")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("Navigator.deviceMemory")}}</li>
 <li>{{HTTPHeader("Device-Memory")}} header</li>
</ul>
